import time
import requests
def fetchStockData(symbol, start, end):
    while(True):
        try:
            response = requests.get('https://sandbox.tradier.com/v1/markets/history',
                        params={'symbol': symbol, 'interval': 'daily', 'start': start, 'end': end},
                        headers={'Authorization': 'Bearer Nc5tYVllbqTzIcTJdvlJK5BG6UKM', 'Accept': 'application/json'})
            return response.json().get("history", {}).get("day", [])
        except AttributeError:
            print("Data does not exist.")
            raise
        except OSError:
            print("Data limit exceeded on options data. Waiting.")
            time.sleep(20)

def fetchOptionData(symbol, expiration, start, end, strike):
    expiration = expiration.replace('-','')
    year = expiration[2:4]
    month = expiration[4:6]
    day = expiration[6:8]
    
    if str(strike).count('.') > 0:
        strike_int = int(str(strike).split('.')[0])
        strike_float = str(strike).split('.')[1]
        for i in range(len(strike_float),3):
            strike_float = strike_float + '0'
        strike_float = strike_float
    else:
        strike_int = strike
        strike_float = '000'
    
    while(True):
        try:
            chain = "{symbol}{y}{m}{d}C{strike_int:05d}{strike_float}&start={start}&end={end}&interval=daily".format(symbol=symbol, y=
                        year, m=month, d=day, strike_int=strike_int, strike_float = strike_float, start=start, end=end)
            response = requests.get('https://sandbox.tradier.com/v1/markets/history?symbol='+chain,
                        headers={'Authorization': 'Bearer Nc5tYVllbqTzIcTJdvlJK5BG6UKM', 'Accept': 'application/json'})

            return response.json().get("history", {}).get("day", [])

        except AttributeError:
                raise
        except OSError:
                print("Data limit exceeded on options data. Waiting.")
                time.sleep(20)