import datetime
from curtin_options_tools import fetch
from curtin_options_tools import helper

def tradingModel(data):
    buys = []
    
    for i in data.items():
        if i[1]['ratio'] <= 0.8:
            expiration = helper.str2datetime(i[0]) + datetime.timedelta((4-helper.str2datetime(i[0]).weekday()) % 7) + datetime.timedelta(14)
            expiration = str(expiration)
            previous = False
            for k in buys:
                if k[0] == expiration:
                    previous = True
            if previous == False:
                buys.append([expiration, i[0], i[1]['close']])
    
    return buys

def profit(buys, symbol):
    profit = 0
    holding = 0
    for i in buys:
        expiration = i[0]
        purchase = i[1]
        price = i[2]
        
        strike = 2.5 * round(price/2.5)
        try:
            premium = fetch.fetchOptionData(symbol, expiration, purchase, purchase, strike)
            premium = premium['close']
        except AttributeError:
            try:
                expiration = str(helper.str2datetime(expiration) - datetime.timedelta(1))
                premium = fetch.fetchOptionData(symbol, expiration,
                                          purchase, purchase, strike)
                premium = premium['close']
            except AttributeError:
                try:
                    strike = 5 * round(price/5)
                    premium = fetch.fetchOptionData(symbol, expiration, purchase, purchase, strike)
                    premium = premium['close']
                except:
                    print(expiration + ' options data for ' + purchase + ' do not exist!')
                    premium = None
        if premium != None:
            cost = fetch.fetchStockData(symbol, expiration, expiration)
            cost = cost['close']
            if (strike + premium) <= cost:
                profit = profit + (cost - (strike + premium))
            else:
                profit = profit - premium
            holding = holding + (cost - price)
    return profit, holding